//+------------------------------------------------------------------+
//|                                                   Envelope95.mq4 |
//|                                                           Kirill |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Kirill"
#property link      "StockProgrammer@mail.ru"
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- indicator parameters
extern int MA_Period = 55;
extern int MA_Shift = 0;
extern int MA_Method = 1;
extern int MA_Price = 0;
//---- statistic parameters
extern string NOTE = "Statistical Parameters";
extern int N = 100;  
extern double fract = 0.95;
double deviation = 0.0;
//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexShift(0,0);
   SetIndexShift(1,0);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=14;
   draw_begin=MA_Period-1;
//---- indicator short name
   IndicatorShortName("Env("+MA_Period+")");
   SetIndexLabel(0,"Env("+MA_Period+")Upper");
   SetIndexLabel(1,"Env("+MA_Period+")Lower");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);



//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   
//---- deviation
   count();   
   
   if(Bars<=MA_Period) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   limit=Bars-ExtCountedBars;
//---- EnvelopesM counted in the buffers
   for(int i=0; i<limit; i++)
     { 
      ExtMapBuffer1[i] = (1+deviation/100) * iMA(NULL, 0, MA_Period, MA_Shift, MA_Method, MA_Price, i);
      ExtMapBuffer2[i] = (1-deviation/100) * iMA(NULL, 0, MA_Period, MA_Shift, MA_Method, MA_Price, i);
     }
//---- done
   deviation = 0;
   return(0);
  }
//+------------------------------------------------------------------+

int count()
{
// envelopes
   double part, K=0, N_ = N, lower, upper;
   int i;
   
   while(1)
   {
      deviation += 0.05;   
      for(i=1; i<=N; i++)
      {
         lower = iEnvelopes(Symbol(), 0, MA_Period, MA_Method, MA_Shift, MA_Price, deviation, MODE_LOWER, i);
         upper = iEnvelopes(Symbol(), 0, MA_Period, MA_Method, MA_Shift, MA_Price, deviation, MODE_UPPER, i);
         if(Open[i] <  upper
            && Close[i] < upper
               && Open[i] > lower
                  && Close[i] > lower)
                     K++;      
      }
      part = K / N_;
      if(part >= fract)
         break;
      else
         K = 0;   
   }
   
   return(0);
}